######################################################################
# tdiary.skin.cgi - This is PyukiWiki, yet another Wiki clone.
# $Id: tdiary.skin.cgi,v 1.5 2012/09/11 00:43:30 papu Exp $
# Build on 2012-09-11 08:30:45
#
# "PyukiWiki" ver 0.2.1-beta2 $$
# Copyright (C) 2004-2007 Nekyo
# Copyright (C) 2005-2012 PyukiWiki Developers Team
# http://pyukiwiki.info/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sfjp.jp/
# License: GPL3 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return:CRLF Code=UTF-8 1TAB=4Spaces
######################################################################
# tdiary お試しテーマwrapper
#
# 参考
#
# http://pukiwiki.sfjp.jp/dev/?BugTrack/769
#
# ダウンロード
# http://sf.net/projects/tdiary/files/theme/
#
# 使い方
# skin/theme 以下に、解凍した約300フォルダのスキンをアップロードする
# $::skin_name="tdiary"; にする
# $::skin_tdiary_name="選択したテーマ"; にする
# 必要であれば、個別調整を、skin/theme/選択したテーマ.css で保存する。
# $::skin_tdiary_selector="テーマ:別名,テーマ:別名";とすることで、
#    setting.inc.cgi から選択できるようになる
# $::skin_tdiary_base で、tdiaryスキンのベースの場所を設定できます。
######################################################################
sub skin {
	my ($pagename, $body, $is_page, $bodyclass, $editable, $admineditable, $basehref, $lastmod) = @_;
	my($page,$message,$errmessage)=split(/\t/,$pagename);
	my $cookedpage = &encode($page);
	my $cookedurl=&make_cookedurl($cookedpage);
	my $escapedpage = &htmlspecialchars($page);
	my $escapedpage_short=$escapedpage;
	$escapedpage_short=~s/^.*\///g if($::short_title eq 1);
	my $HelpPage = &encode($::resource{help});
	my $htmlbody;
	my ($title,$headerbody,$menubarbody,$sidebarbody,$footerbody,$notesbody);
	# サブページの読み込み
	my $flg= $::form{cmd}!~/^(ad|admin|adminchangepassword|compressbackup|deletecache|edit|freezeconvert|listfrozen|logs\_viewer|server)/ ? 1 : 0;
	my ($menubarbody, $headerbody, $sidebarbody);
	my ($bodyheaderbody, $bodyfooterbody);
	my ($footerbody, $titleheaderbody, $skinfooterbody);
	my %subbody=&skinsubpage(
		$::MenuBar, $::Header, $::SideBar, $::BodyHeader, $::BodyFooter,
		$::TitleHeader, $::Footer, $::SkinFooter);
	if($is_page || $::allview eq 1) {
		$menubarbody=$subbody{$::MenuBar};
		if($flg) {
			$headerbody=$subbody{$::Header};
			$bodyheaderbody=$subbody{$::BodyHeader};
			$bodyfooterbody=$subbody{$::BodyFooter};
			$footerbody=$subbody{$::Footer};
		}
	}
	# :TitleHeader
	$skinfooterbody=$subbody{$::SkinFooter};
	# 注釈HTMLの生成
	if (@::notes) {
		$notesbody.= << "EOD";
<div id="note">
<hr class="note_hr" />
EOD
		my $cnt = 1;
		foreach my $note (@::notes) {
			$notesbody.= << "EOD";
<a id="notefoot_$cnt" href="@{[&make_cookedurl($::form{mypage})]}#notetext_$cnt" class="note_super">*$cnt</a>
@{[$::notesview ne 0 ? qq(<span class="small">) : '']}@{[$note]}@{[$::notesview ne 0 ? qq(</span>) : '']}
<br />
EOD
			$cnt++;
		}
		$notesbody.="</div>\n";
	}
	# changed on v0.2.0 moved on v0.2.0-p2
	# <title>タグの生成
	my($title, $title_tag)=&maketitle($page, $message);
	# changed on v0.2.1 説明
	$description=qq(\n<meta name="description" content="@{[$::IN_TITLE eq '' ? "$title - $escapedpage" : $::IN_TITLE]}" />)
		if($::IN_META_ROBOTS!~/<meta name="description"/);
	$::skin_tdiary_name=$::skin_tdiary_selector && $::setting_cookie{tdiarystyle} ? $::setting_cookie{tdiarystyle} : $::skin_tdiary_name;
	$::skin_tdiary_name=~s/\///g;
	# tdiary用個別調整
	if($::skin_tdiary_name=~/^asterisk/) {
		$::IN_CSSHEAD.=<<EOM;
div.sidebar {
 position:absolute;
 top:100;
 right:100;
 margin-right:80px;
 margin-top: 150px;
}
EOM
	}
	if($::skin_tdiary_name=~/^90$/) {
		$::IN_CSSHEAD.=<<EOM;
.sidebar {
	position: absolute;
	top: 50px;
	right: 0px;
	width: 150px;
	border-top: solid 1px #606060;
}
EOM
	}
	if($::skin_tdiary_name=~/aqua/) {
		$::IN_CSSHEAD.=<<EOM;
div.sidebar {
 margin-right:50px;
 margin-top: 130px;
 width:150px;
}
h3 {
  margin-left: 0px;
  margin-right: 0px;
}
div.main {
  margin-right: 200px;
}
EOM
	}
	if($::skin_tdiary_name=~/^wall/) {
		$::IN_CSSHEAD.=<<EOM;
div.sidebar {
 position:absolute;
 top:100;
 right:100;
 margin-right:10px;
 margin-top: 52px;66
 width:150px;
 border-top: solid 1px #606060;
}
h3 {
  margin-left: 0px;
  margin-right: 0px;
}
div.main {
  margin-right: 200px;
}
EOM
	}
	$::skin_tdiary_base="theme";# if($::skin_tdiary_base eq "");
	#&jscss_include("$::skin_tdiary_base/base");
	&jscss_include("$::skin_tdiary_base/$::skin_tdiary_name/$::skin_tdiary_name");
	&jscss_include("$::skin_tdiary_base/$::skin_tdiary_name");	# 個別調整
	# <head>の調整
	&skinhead($pagename);
	# HTML <head>丫</head> から、画像リンクまで
	$htmlbody=<<"EOD";
$::dtd
<title>$title_tag</title>
@{[$basehref eq '' ? '' : qq(<base href="$basehref" />)]}
@{[$::AntiSpam ne "" || $::modifier_mail eq "" ? '' : qq(<link rev="made" href="mailto:$::modifier_mail" />)]}
<link rel="top" href="$::script" />
<link rel="index" href="$::script?cmd=list" />
@{[$::use_SiteMap eq 1 ? qq(<link rel="contents" href="$::script?cmd=sitemap" />) : '<link rel="contents" href="' . $::script . '?cmd=list" />']}
<link rel="search" href="$::script?cmd=search" />
<link rel="help" href="$::script?$HelpPage" />
<link rel="author" href="$::modifierlink" />@{[$description]}
<meta name="author" content="$::modifier" />
<meta name="copyright" content="$::modifier" />
$::IN_HEAD</head>
<body class="$bodyclass"$::IN_BODY>
<div id="container">
<div id="head">
<div id="header">
EOD
	# ナビゲータの表示
	$htmlbody.=<<EOD;
</div>
<div class="adminmenu">
<div id="navigator">
EOD
	my $flg=0;
	foreach $name (@::navi) {
		if($name eq '') {
			$flg=0;
		} else {
			if($::navi{"$name\_html"} ne '') {
				$flg=1;
				$htmlbody.=$::navi{"$name\_html"};
			} elsif($::navi{"$name\_name"} ne '') {
				$flg=1;
				$htmlbody.=<<EOD;
<span class="adminmenu"><a title="@{[$::navi{"$name\_title"} eq '' ? $::navi{"$name\_name"} : $::navi{"$name\_title"}]}" href="$::navi{"$name\_url"}">$::navi{"$name\_name"}</a></span>
EOD
			}
		}
	}
	$htmlbody.=<<EOD;
</div>
</div>
</div>
<h1>$::wiki_title</h1>
EOD
	# table定義
#<div id="content">
#<table class="content_table" border="0" cellpadding="0" cellspacing="0">
#@{[$headerbody ne '' ? qq(<tr><td@{[$colspan ne 1 ? qq( colspan="$colspan") : '']}><div id="headerbody">$headerbody</div></td></tr>) : '']}
#  <tr>
#EOD
	# MenuBarの表示
	if($menubarbody ne '') {
		$htmlbody.=<<"EOD";
    <div class="sidebar">
    <div id="menubar">
$menubarbody
    </div>
    </div>
</div>
EOD
	}
	$htmlbody.=<<EOD;
<div class="pkwk_body">
<div class="main">
<hr class="sep" />
<div class="day">
EOD
	# ページタイトル、メッセージの表示
	if($errmessage ne '') {
		$htmlbody.=<<EOD;
<h2>$errmessage</h2>
EOD
	} elsif($page ne '') {
		$htmlbody.=<<EOD;
<h2>$escapedpage_short@{[$message eq '' ? '' : "&nbsp;$message"]}</h2>
EOD
	} else {
		$htmlbody.=<<EOD;
<h2>$message</h2>
EOD
	}
	# コンテンツの表示
	$htmlbody.= <<"EOD";
<div class="body">
@{[$headerbody ne '' ? qq(<div id="headerbody">$headerbody</div>) : '']}
@{[$bodyheaderbody ne '' ?  qq(<div id="bodyheaderbody">$bodyheaderbody</div>\n) : ""]}<div>$body</div>@{[$::notesview eq 0 ? $notesbody : '']}@{[$bodyfooterbody ne '' ? qq(\n<div id="bodyfooterbody">$bodyfooterbody</div>) : ""]}
@{[$footerbody ne '' ? qq(<div id="footerbody">$footerbody</div>) : '']}
</div>
</div>
EOD
	# SideBarの表示
#    <td class="sidebar" valign="top">
#    <div id="sidebar">
#$sidebarbody
#    </div>
#    </td>
#EOD
	# 下の表示
	$htmlbody.= << "EOD";
@{[$::notesview eq 1 ? qq($notesbody) : '']}
EOD
	# 注釈の表示（:Footerの下）
	$htmlbody.=$::notesview eq 2 ? $notesbody : '';
	# アイコン、lastmodified表示
	$htmlbody.= <<"EOD";
</div>
<div id="foot">
<div id="toolbar">
EOD
	if($::toolbar ne 0) {
		foreach $name (@::navi) {
			if($name eq '') {
				$htmlbody.=" &nbsp; ";
			} else {
				if(-f "$image_dir/$name.png") {
					if($::toolbar eq 2 || $::navi{"$name\_height"} ne '') {
						my $height=$::navi{"$name\_height"} eq '' ? 20 : $::navi{"$name\_height"};
						my $width=$::navi{"$name\_width"} eq '' ? 20 : $::navi{"$name\_width"};
						$htmlbody.=<<EOD;
	<a title="@{[$::navi{"$name\_title"} eq '' ? $::navi{"$name\_name"} : $::navi{"$name\_title"}]}" href="$::navi{"$name\_url"}"><img alt="@{[$::navi{"$name\_title"} eq '' ? $::navi{"$name\_name"} : $::navi{"$name\_title"}]}" src="$image_url/$name.png" height="$height" width="$width" /></a>
EOD
					}
				}
			}
		}
	}
	$htmlbody.=<<EOD;
</div>
@{[ $::last_modified == 2 || 1
 ? qq(
<div class="referer">$::lastmod_prompt $lastmod</div>)
 : qq()
]}
<div class="footer">
EOD
	# ページフッタ wiki文法
	# lang=ja
	if($::lang eq 'ja') {
		$footerbody=<<EOD;
@{[$::wiki_title ne '' ? qq(''[[$::wiki_title>$basehref]]'' ) : '']}Modified by [[$::modifier>$::modifierlink]]~
\$skinfooterbody
~
''[[PyukiWiki $::version>http://pyukiwiki.info/]]''
Copyright&copy; 2004-2012 by Nekyo, [[PyukiWiki Developers Team>http://pyukiwiki.info/]]
License is [[GPL>http://sfjp.jp/projects/opensource/wiki/GPLv3_Info]], [[Artistic>http://www.opensource.jp/artistic/ja/Artistic-ja.html]]~
Based on "[[YukiWiki>http://www.hyuki.com/yukiwiki/]]" 2.1.0 by [[yuki>http://www.hyuki.com/]]
and [[PukiWiki>http://pukiwiki.sfjp.jp/]] by [[PukiWiki Developers Term>http://pukiwiki.sfjp.jp/]]~
EOD
	} else {
	# lang=en and/or other
		$footerbody=<<EOD;
@{[$::wiki_title ne '' ? qq(''[[$::wiki_title>$basehref]]'' ) : '']}Modified by [[$::modifier>$::modifierlink]]
\$skinfooterbody
~
''[[PyukiWiki $::version>http://pyukiwiki.info/]]''
Copyright&copy; 2004-2012 by Nekyo, [[PyukiWiki Developers Team>http://pyukiwiki.info/]]
License is [[GPL>http://www.gnu.org/licenses/gpl.html]], [[Artistic>A]]~
Based on "[[YukiWiki>http://www.hyuki.com/yukiwiki/]]" 2.1.0 by [[yuki>http://www.hyuki.com/]]
and [[PukiWiki>http://pukiwiki.sfjp.jp/]] by [[PukiWiki Developers Term>http://pukiwiki.sfjp.jp/]]~
EOD
	}
	$footerbody= &text_to_html($footerbody);
	$footerbody=~s/\$skinfooterbody/$skinfooterbody/;
	$footerbody=~s/(<p>|<\/p>)//g;
	$htmlbody.= $footerbody;
	$htmlbody.= <<"EOD";
@{[&convtime]}
</div>
</div>
</div>
</body>
</html>
EOD
	return $htmlbody;
}
1;
